%----------------------------------------------%
%    Simulation of a bank robbery	       %
%    written by Ivan Futo		       %
%----------------------------------------------%

problem:-
   new(dick_gets_the_money(prolog_savings),dick,0,25,1),
   new(jim_gets_the_money(prolog_savings),jim,0,25,2).

jim_gets_the_money(BANK):-
   jim_climbs_into(BANK),  chooses(SAFE),  send(safe(SAFE),[dick]),
   wait_for(tools(TOOLS)),  opens(SAFE,TOOLS),	outputs(SAFE,BANK).

dick_gets_the_money(BANK):-
   wait_for(safe(SAFE)),  has(TOOLS,SAFE),  send(tools(TOOLS),[jim]).

chooses(wertheim).
chooses(milner).
chooses(chatwood).

has(tool_set_a,milner).
has(tool_set_b,chatwood).

jim_climbs_into(BANK):-
   during(5).

opens(milner,TOOLS):-
   during(40).
opens(chatwood,TOOLS):-
   during(10).

outputs(SAFE,BANK):-
   local_time(T),  write("the bandits got the money from the safe "),
   write(SAFE), write(" in the "),  write(BANK),
   write(" bank at time "),  write(T),  write(.),  nl.

during(T):-
   advance(T).

